// -*- C++ -*- generated by wxGlade 0.6.5 on Fri Sep 14 09:37:57 2012

#include <wx/wx.h>
#include <wx/image.h>
// begin wxGlade: ::dependencies
#include <wx/statline.h>

// end wxGlade

#include "../../assertion.h"

#ifndef COLOURKEYFRAMEDIALOG_H
#define COLOURKEYFRAMEDIALOG_H


// begin wxGlade: ::extracode
// end wxGlade


class ColourKeyFrameDialog: public wxDialog {
public:
	// begin wxGlade: ColourKeyFrameDialog::ids
	// end wxGlade

	ColourKeyFrameDialog(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_DIALOG_STYLE);

	size_t getTransitionMode() const { return transitionMode;};

	//Get the staring colour as a hex string
	std::string getStartValue() const;
	//Get the ending colour as a hex string
	std::string getEndValue() const;

	size_t getStartFrame() const { ASSERT(startFrameOK); return startFrame;};

	size_t getEndFrame() const { ASSERT(endFrameOK); return endFrame;};
private:
	// begin wxGlade: ColourKeyFrameDialog::methods
	void set_properties();
	void do_layout();
	// end wxGlade

	//Starting gred, green and blue values for transition
	unsigned char startRed,startGreen, startBlue;
	unsigned char endRed,endGreen, endBlue;
	size_t startFrame,endFrame;
	size_t transitionMode;
	
	bool startFrameOK,endFrameOK;

	//!Update the OK button's enabled/disabled state 
	// based upon text field validity
	void updateOKButton();
	//!Update the colour chooser buttons appearance
	void updateButtonColours();

protected:
	// begin wxGlade: ColourKeyFrameDialog::attributes
	wxStaticBox* sizerMainArea_staticbox;
	wxStaticText* labelTransition;
	wxComboBox* comboTransition;
	wxStaticText* labelFrameStart;
	wxTextCtrl* textFrameStart;
	wxStaticText* labelFrameEnd;
	wxTextCtrl* textFrameEnd;
	wxStaticLine* verticalLine;
	wxStaticText* labelStartVal;
	wxButton* btnStartColour;
	wxStaticText* labelFinalVal;
	wxButton* btnEndColour;
	wxButton* buttonCancel;
	wxButton* buttonOK;
	// end wxGlade

	DECLARE_EVENT_TABLE();

public:
	virtual void OnComboTransition(wxCommandEvent &event); // wxGlade: <event_handler>
	virtual void OnTextStartFrame(wxCommandEvent &event); // wxGlade: <event_handler>
	virtual void OnTextEndFrame(wxCommandEvent &event); // wxGlade: <event_handler>
	virtual void OnBtnStartColour(wxCommandEvent &event); // wxGlade: <event_handler>
	virtual void OnBtnEndColour(wxCommandEvent &event); // wxGlade: <event_handler>
}; // wxGlade: end class


#endif // COLOURKEYFRAMEDIALOG_H
